<?php
add_action('wp_footer', 'qc_fab_load_footer_html');
function qc_fab_load_footer_html()
{ ?>
<div id="floating_action_button-icon-container" class="floating_action_button-<?php echo get_option('qc_floating_action_button_mode') ?>-container floating_action_button-main-container">
    <style>
        <?php if(get_option('qc_fab_custom_global_css')!=''){echo get_option('qc_fab_custom_global_css');}?>
    </style>
    <?php if (get_option('qc_floating_action_button_disable') == 1 && qc_fab_load_controlling()==true ):
    $itemCount = '';
    //icon handling by wp media
    if(get_option('qc_fab_custom_icon_path')!="" && get_option('qc_fab_icon')=="custom.png"  ){
        $qc_fab_custom_icon_path=get_option('qc_fab_custom_icon_path');
    }else if(get_option('qc_fab_custom_icon_path')!="" && get_option('qc_fab_icon')!="custom.png"){
        $qc_fab_custom_icon_path=QC_FLOATING_ACTION_BUTTON_IMG_URL.get_option('qc_fab_icon');
    }else{
        $qc_fab_custom_icon_path=QC_FLOATING_ACTION_BUTTON_IMG_URL .'custom.png';
    }
    //custom quick ball path
    if (get_option('qc_fab_custom_quickball_path') != "") {
        $qc_fab_custom_quickball_path = get_option('qc_fab_custom_quickball_path');
    } else {
        $qc_fab_custom_quickball_path = QC_FLOATING_ACTION_BUTTON_IMG_URL . 'custom.png';
    }
    //floating_action_button modes handling.
    if (get_option('qc_floating_action_button_mode') == 'vertical') {
        //Vertical Ball
        ?>
        <div id="floating_action_button-ball-wrapper" class="floating_action_button-vertical-mode">
            <div id="floating_action_button-pinball-box" style="display:none" class="floating_action_button-ball-container animated">
                <div  class="floating_action_button-close-quickball-popup" id="floating_action_button-close-quickball-popup">  </div>
                <div class="floating_action_button-ball-inner"> </div>
            </div>
            <!--floating_action_button-ball-container-->

            <!-----------------------------------
                START ICON AREA
            ----------------------------------->
            <div class="floating_action_button-ball-area">
                <div id="floating_action_button-vertical-ball" class="floating_action_button-vertical-ball">
                    <ul>
                        <?php 

                        if (get_option('qc_floating_action_button_search') != "") { ?>
                            <li class="floating_action_button-ball-style" data-ball-style="4"><a style="cursor:pointer"></a>
                                <div class="floating_action_button-label"><?php echo(get_option('qc_fab_vertical_search') != '' ? get_option('qc_fab_vertical_search') : 'Search'); ?></div>
                            </li>
                        <?php }
                        
                        if (get_option('qc_fab_support_quickball') != "") { ?>
                            <li class="floating_action_button-ball-style" data-ball-style="6"><a style="cursor:pointer"></a>
                                <div class="floating_action_button-label"><?php echo(get_option('qc_fab_vertical_support') != '' ? get_option('qc_fab_vertical_support') : 'Support'); ?></div>
                            </li>
                        <?php }

                        if (get_option('qc_fab_custom_quickball') != "") { ?>
                            <li class="floating_action_button-ball-style" data-ball-style="5"><a
                                        style="background-image: url(<?php echo $qc_fab_custom_quickball_path; ?>) !important;background-size: cover;"
                                        href="<?php echo(get_option('qc_fab_custom_quickball_link') != '' ? get_option('qc_fab_custom_quickball_link') : site_url()); ?>"
                                        target="_blank"></a>
                                <div class="floating_action_button-label"><?php echo(get_option('qc_fab_vertical_custom') != '' ? get_option('qc_fab_vertical_custom') : 'Go To'); ?></div>
                            </li>
                        <?php }

                        $qc_fab_social_icon_urls   = unserialize( get_option('qc_fab_social_icon_url'));

                        $qc_fab_social_titles      = unserialize( get_option('qc_fab_social_title'));
                        $qc_fab_social_urls        = unserialize( get_option('qc_fab_social_url'));
                        $qcld_disable_qc_fab_custom_quickballs  = unserialize( get_option('qcld_disable_qc_fab_custom_quickballs'));

                        if ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off') || $_SERVER['SERVER_PORT'] == 443) {
                            $current_url="https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        }else{
                            $current_url="http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        }


                        if ($qc_fab_social_icon_urls != '') {

                            for($i = 0; $i<count($qc_fab_social_icon_urls); ++$i) {

                                if (isset($qcld_disable_qc_fab_custom_quickballs[$i]) && $qcld_disable_qc_fab_custom_quickballs[$i] == 'enable_qc_fab_custom_quickball') {

                                    if(isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='url'){
                                        $qcld_custom_url = $qc_fab_social_urls[$i];
                                        $qcld_custom_social_url_lang =(get_option('qc_fab_lang_social_url') != '' ? get_option('qc_fab_lang_social_url') : 'URL');
                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="'.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_url_lang, 'floating-action-button').'</div></li>';
                                    }

                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='phone'){
                                        $qcld_custom_url = $qc_fab_social_urls[$i];
                                        $qcld_custom_social_phone_lang =(get_option('qc_fab_lang_social_phone') != '' ? get_option('qc_fab_lang_social_phone') : 'Phone');
                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="tel:'.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_phone_lang, 'floating-action-button').'</div></li>';
                                    }
                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='mail'){
                                        $qcld_custom_url = $qc_fab_social_urls[$i];
                                        $qcld_custom_social_mail_lang =(get_option('qc_fab_lang_social_email') != '' ? get_option('qc_fab_lang_social_email') : 'Mail');

                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="mailto:'.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_mail_lang, 'floating-action-button').'</div></li>';
                                    }
                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='facebook'){
                                        
                                        $qcld_custom_url = $qc_fab_social_urls[$i] ? $qc_fab_social_urls[$i] : $current_url;
                                        $qcld_custom_social_facebook_lang =(get_option('qc_fab_lang_social_facebook') != '' ? get_option('qc_fab_lang_social_facebook') : 'Facebook');

                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="https://www.facebook.com/sharer/sharer.php?u='.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_facebook_lang, 'floating-action-button').'</div></li>';
                                    }
                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='twitter'){

                                        $qcld_custom_url = $qc_fab_social_urls[$i] ? $qc_fab_social_urls[$i] : $current_url;
                                        $qcld_custom_social_twitter_lang =(get_option('qc_fab_lang_social_twitter') != '' ? get_option('qc_fab_lang_social_twitter') : 'Twitter');

                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="https://twitter.com/intent/tweet?url='.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_twitter_lang, 'floating-action-button').'</div></li>';
                                    }
                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='whatsapp'){

                                        $qcld_custom_url = $qc_fab_social_urls[$i] ? $qc_fab_social_urls[$i] : $current_url;
                                        $qcld_custom_social_whatsapp_lang =(get_option('qc_fab_lang_social_whatsapp') != '' ? get_option('qc_fab_lang_social_whatsapp') : 'Whatsapp');

                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="https://api.whatsapp.com/send?link:'.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_whatsapp_lang, 'floating-action-button').'</div></li>';
                                    }
                                    if (isset($qc_fab_social_titles[$i]) && $qc_fab_social_titles[$i]=='linkedin'){
                                        // $qcld_custom_url = $current_url;
                                        $qcld_custom_url = $qc_fab_social_urls[$i] ? $qc_fab_social_urls[$i] : $current_url;
                                        $qcld_custom_social_linkedin_lang =(get_option('qc_fab_lang_social_linkedin') != '' ? get_option('qc_fab_lang_social_linkedin') : 'Linkedin');

                                        echo '<li class="floating_action_button-ball-style" data-ball-style="5"><a
                                            style="background-image: url('.esc_url($qc_fab_social_icon_urls[$i]).') !important;background-size: cover;"
                                            href="http://www.linkedin.com/shareArticle?mini=true&url='.esc_url($qcld_custom_url).'"
                                            target="_blank"></a><div class="floating_action_button-label">'.__($qcld_custom_social_linkedin_lang, 'floating-action-button').'</div></li>';
                                    }
                        
                        
                                } 
                            } 
                        }

                         ?>
                    </ul>
                    <img src="<?php echo esc_url($qc_fab_custom_icon_path); ?>" alt="Floating Action Button Icon">
                   
                </div>
                <!--floating_action_button-floating-ball-->
            </div>
            <!--floating_action_button-ball-area-->
            <!------------------------------
                    END ICON AREA
                    ------------------------->
        </div>
        <!--floating_action_button-ball-wrapper-->
        <?php


    }
    ?>
    <?php $message_status = get_option('qc_floating_action_button_disable_notification');
    if ($message_status == 1) {
        // Nothing to do
    } else {
        ?>
        <div class="floating_action_button-tooltop-message-area">
            <div class="tooltip-effect-4 qcld_floating_action_button_tooltip" id="qcld_floating_action_button_tooltip"
                 data-loop="<?php if (get_option('qc_floating_action_button_loop_notification') == 1) {
                     echo 1;
                 } else {
                     echo 0;
                 }; ?>">
                <div class="tooltip-content">
                    <ul class="qcld_floating_action_button_msg" id="qcld_floating_action_button_msg" data-global-timer="<?php echo get_option('qc_fab_global_notification_delay_time'); ?>">
                        <?php if (get_option('qc_fab_message_one') != ''): ?>
                            <li class="floating_action_buttonMsgItem"><?php _e(get_option('qc_fab_message_one'), 'floating-action-button'); ?></li>
                        <?php endif; ?>
                        <?php if (get_option('qc_fab_message_two') != ''): ?>
                            <li class="floating_action_buttonMsgItem"><?php _e(get_option('qc_fab_message_two'), 'floating-action-button'); ?></li>
                        <?php endif; ?>
                    </ul>
                </div>
                <!-- tooltip-content-->
            </div>

        </div>
        <!-- floating_action_button-tooltop-message-area-->
        </div>
    <?php } ?>
<?php endif;

}
//Checking the floating_action_button load controlling.
function qc_fab_load_controlling(){
    $qc_fab_load=true;
    if(get_option('qc_fab_show_home_page')=='off' && is_home()){
        $qc_fab_load=false;
    }
    if(get_option('qc_fab_show_posts')=='off' && 'post' == get_post_type()){
        $qc_fab_load=false;
    }

    if(get_option('qc_fab_show_pages')=='off'){
        $qc_fab_select_pages=unserialize(get_option('qc_fab_show_pages_list'));
        if(is_page() && !empty($qc_fab_select_pages) ){
            //$page_id=get_the_ID();
            if(in_array(get_the_ID(), $qc_fab_select_pages) == true){
                $qc_fab_load=true;
            }else{
                $qc_fab_load=false;
            }
        }
    }

    return $qc_fab_load;
}



/***************** On page ajax search and others end ******************/
/***************** Pinball Start******************/
add_action('wp_ajax_pin_ball_mode', 'qcld_floating_action_button_pin_ball_mode');
add_action('wp_ajax_nopriv_pin_ball_mode', 'qcld_floating_action_button_pin_ball_mode');

function qcld_floating_action_button_pin_ball_mode()
{
    $style = $_POST['style'];
    $html = "<div class='animated'>";
    if ($style == 6) { //floating_action_button Support
        $html .= '<div class="floating_action_button-support-form-container"> 
                 <h2 class="qc_fab_title">'.(get_option('qc_fab_support_form_title') ? get_option('qc_fab_support_form_title') : 'Questions or Comments? Contact Us').'</h2>
                <div class="floating_action_button-support-form-fullname">
                    <input id="floating_action_button_support_fullname" type="text" name="floating_action_button_support_fullname" placeholder="'.(get_option('qc_fab_support_form_lan_full_name') ? get_option('qc_fab_support_form_lan_full_name') : 'Full Name').'">
                </div>
                <div class="floating_action_button-support-form-email">
                    <input id="floating_action_button_support_email" type="text" name="floating_action_button_support_email" placeholder="'.(get_option('qc_fab_support_form_lan_email_address') ? get_option('qc_fab_support_form_lan_email_address') : 'Email Address').'">
                </div>
                <div class="floating_action_button-support-form-message">
                    <textarea  id="floating_action_button_support_Message" name="floating_action_button_support_Message" rows="2" cols="20" placeholder="'.(get_option('qc_fab_support_form_lan_message') ? get_option('qc_fab_support_form_lan_message') : 'Message').'"></textarea>
                </div>
				<div class="floating_action_button-support-form-action">
                <div class="floating_action_button-support-form-captcha"> 
                   <div id="floating_action_button-captcha" class="floating_action_button-captcha-view">
                     <span id="floating_action_button-captcha-code"></span>
                     <button type="button" id="qc_fab-captcha-refresh">Refresh</button>
                   </div>
                   <div class="floating_action_button-captcha-fields">
                      <input type="text" id="qc_fab-captcha" class="captcha" maxlength="4" size="4" placeholder="Enter captcha code" tabindex=3 />
                   </div>
                </div>
                <div class="floating_action_button-support-form-submit">
					<div class="floating_action_button-clear"></div>
                    <button type="button" id="floating_action_button-support-form-submit">'.(get_option('qc_fab_support_form_lan_submit') ? get_option('qc_fab_support_form_lan_submit') : 'Submit').'</button>
					<div class="floating_action_button-clear"></div>
                </div>
				</div>
				<div class="floating_action_button-support-form-val">
				<span id="floating_action_button-support-form-validation" style="color:red"></span>
				</div>
                </div>';
    } else if ($style == 4) { //Search features
       $html .= do_shortcode("[qc_floating_action_button]");
    } 
    $html .= "</div>";
    echo wp_send_json($html);
    wp_die();
}


add_shortcode( 'qc_floating_action_button', 'floating_action_button_frontend_shortcodes' );
function floating_action_button_frontend_shortcodes($atts)
{

   extract(shortcode_atts(array(
        'title' => "",
        'font_size' => false,
        'color' => "#8e9396",
        'theme' => 'light'
    ), $atts));

    $list = '<div  class="qcld_woofloating_action_button">
                <div class="floating_action_button-support-form-container floating_action_button-contact-form-container"> 
                    
                    <div class="floating_action_button-support-form-fullname">
                        <input id="qc_fab_keyword" type="text" name="qc_fab_keyword" placeholder="'.(get_option('qc_fab_keyword_lang_change') ? get_option('qc_fab_keyword_lang_change') : 'Keyword ...').'">
                    </div>
                    <div class="floating_action_button-support-form-submit">
                        <div class="floating_action_button-clear"></div>
                        <button type="button" class="floating_action_button-find-ajax">'.(get_option('qc_fab-search-button-text') ? get_option('qc_fab-search-button-text') : 'Find Them!').'</button>
                        <div class="floating_action_button-clear"></div>
                    </div>
                </div>
            </div>';

    wp_reset_query();
    return $list;
}


//Ajax based search method
add_action('wp_ajax_get_floating_action_button_ajax_search_results', 'qcld_get_floating_action_button_ajax_search_results');
add_action('wp_ajax_nopriv_get_floating_action_button_ajax_search_results', 'qcld_get_floating_action_button_ajax_search_results');

function qcld_get_floating_action_button_ajax_search_results()
{

    $results = new WP_Query( array(
        'post_type'     => array( 'post', 'page' ),
        'post_status'   => 'publish',
        'nopaging'      => true,
        'posts_per_page'=> 10,
        's'             => trim(sanitize_text_field($_POST['qc_fab_keyword'])),
    ) );

    $response = array();
    $response['status'] = 'fail';
    $html = '<div  class="qcld_woofloating_action_button">
                <div class="floating_action_button-support-form-container"> 
                    <div class="floating_action_button-support-form-fullname">
                        <input id="qc_fab_keyword" type="text" name="qc_fab_keyword" placeholder="'.(get_option('qc_fab_keyword_lang_change') ? get_option('qc_fab_keyword_lang_change') : 'Keyword ...').'" value="'.esc_attr($_POST['qc_fab_keyword']).'">
                    </div>
                    <div class="floating_action_button-support-form-submit">
                        <div class="floating_action_button-clear"></div>
                        <button type="button" class="floating_action_button-find-ajax">'.(get_option('qc_fab-search-button-text') ? get_option('qc_fab-search-button-text') : 'Find Them!').'</button>
                        <div class="floating_action_button-clear"></div>
                    </div>
                </div>
            </div>';
    $html      .= '<div class="wpb-search-result">';
    if ( !empty( $results->posts ) ) {
            $html  .= '<p>We have found '.count($results->posts).' results for <b>'.stripslashes($_POST['qc_fab_keyword']).'</b></p>';
        foreach ( $results->posts as $result ) {
            $html  .= '<p><a href="'.get_permalink($result->ID).'" target="_blank">'.$result->post_title.'</a></p>';
            $html  .= '<p class="qc_fab_times"><i>'.get_the_date('F j, Y',$result->ID).'</i></p>';
        }
    }else{

        $html     .=  __('<p>No Result Found! </p>', 'floating-action-button');

    }

    $html     .= '</div>';
   
    $response = array('html' => $html);
    echo wp_send_json($response);
    wp_die();

}


add_action('wp_ajax_pin_ball_support', 'qcld_floating_action_button_pin_ball_support');
add_action('wp_ajax_nopriv_pin_ball_support', 'qcld_floating_action_button_pin_ball_support');

function qcld_floating_action_button_pin_ball_support()
{
    $email_page_link = trim(sanitize_text_field($_POST['link']));
    $name = trim(sanitize_text_field($_POST['name']));
    $email = trim(sanitize_email($_POST['email']));
    $message = trim(sanitize_text_field($_POST['message']));
    $subject = 'Support Email from Floating Action Button by Client';
    //Extract Domain
    $url = get_site_url();
    $url = parse_url($url);
    $domain = $url['host'];
    $support_email = "admin@" . $domain;
    $toEmail = get_option('qc_fab_support_quickball_email') != '' ? get_option('qc_fab_support_quickball_email') : $support_email;
    $fakeFromEmailAddress = "wordpress@" . $domain;
    //Starting messaging and status.
    $response['status'] = 'fail';
    $response['message'] = __('Sorry! fail to send email.', 'floating-action-button');

    if (filter_var($email, FILTER_VALIDATE_EMAIL) === false) {
        $response['message'] = 'Invalid email address.';
        $response['status'] = 'fail';
    } else {
        //build email body
        $bodyContent = "";

        $bodyContent .= "<p><strong>Support Request Details:</strong></p><hr>";

        $bodyContent .= "<p>Name : " . $name . "</p>";
        $bodyContent .= "<p>Email : " . $email . "</p>";
        $bodyContent .= "<p>Subject : " . $subject . "</p>";
        $bodyContent .= "<p>Message : " . $message . "</p>";
        $bodyContent .= "<p>Email from : " . $email_page_link . "</p>";

        $bodyContent .= "<p>Mail Generated on: " . date("F j, Y, g:i a") . "</p>";


        $to = $toEmail;
        $body = $bodyContent;
        $headers = array();
        $headers[] = 'Content-Type: text/html; charset=UTF-8';
        $headers[] = 'From: ' . $name . ' <' . $fakeFromEmailAddress . '>';
        $headers[] = 'Reply-To: ' . $name . ' <' . $email . '>';

        $result = wp_mail($to, $subject, $body, $headers);

        if ($result) {
            $response['status'] = 'success';
            $response['message'] = __('<div class="floating_action_button-support-email-success"> Your email was sent successfully. <br> Thank You!</div>', 'floating-action-button');
        }
    }
    ob_clean();
    echo json_encode($response);
    die();

}

